<script lang="ts">
	import { createEventDispatcher } from 'svelte';
	import ShadeVisual from './ShadeVisual.svelte';
	import Touchpad from './Touchpad.svelte';
	import {
		controlPositionStore,
		isBeingAdjustedStore,
		touchpadHorizPositionStore,
	} from './store';

	const dispatch = createEventDispatcher();

	let actualPosition: number = 0;

	// Frame Props
	let frameWidth: number = 388;
	let frameHeight: number = 445;
	let frameDepth: number = 16;
	let rollHeight = 30;
	let rollVertPadding = 8;
	let jacketHeight =
		frameHeight -
		rollHeight +
		rollVertPadding -
		frameDepth * 1.5;

	let controlPosition;
	controlPositionStore.subscribe((value) => {
		controlPosition = value;
	});

	let touchpadHorizPosition;
	touchpadHorizPositionStore.subscribe((value) => {
		touchpadHorizPosition = value;
	});

	let isBeingAdjusted;
	isBeingAdjustedStore.subscribe((value) => {
		isBeingAdjusted = value;
	});

	$: positionLineTop =
		controlPosition * jacketHeight +
		rollVertPadding +
		rollHeight -
		// 1/2(ish) the height of the position line
		4;

	$: pointerRingPosition = positionLineTop;
	$: pointerRingLeft = touchpadHorizPosition * frameWidth;

	/**
	 * TODO:: Send Shade's set position command to Box.
	 */
	function onPositionChanged(event) {
		// dispatch('setPosition', {
		// 	position: event.target.value,
		// });
	}

	/**
	 * TODO: Set this up as the recipient of
	 * the state update
	 */
	function onStateUpdate(state) {
		console.log('STATE UPDATED', state);
	}
</script>

<style>
	.container {
		min-width: 430px;
		position: relative;
		padding: 30px 0 0 0;
	}
	.diagnostics {
		user-select: none;
		display: none;
	}
	.visual {
		position: relative;
		z-index: 1;
		width: 388px;
		margin: 0 auto;
	}
	.position-line {
		opacity: 0.5;
		transition: opacity 1.25s;
		position: absolute;
		top: var(--position);
		margin-left: -250px;
		pointer-events: none;
	}
	.position-line.hidden {
		opacity: 0;
		transition: opacity 5s;
	}
	.pointer-ring {
		position: absolute;
		top: var(--position);
		transition: opacity 2s;
		left: var(--position-horiz);
		width: 74px;
		height: 74px;
		margin-left: -37px;
		margin-top: -37px;
		pointer-events: none;
	}
	.pointer-ring.hidden {
		opacity: 0;
	}
	.position-readout {
		display: block;

		font-size: 14px;
		font-weight: bold;
		text-transform: uppercase;

		position: absolute;
		left: 50%;
		top: 26px;
		left: -80px;
		margin-left: -50px;
		min-width: 60px;
	}
	.position-readout p {
		margin: 0;
	}
	.readout-label {
		color: #fff;
	}
	.readout-value {
		color: #999;
		background-color: #fff;
		padding: 2px 10px;
		border-radius: 3px;
	}
</style>

<main class="container">
	<div class="diagnostics">
		<p>isBeingAdjusted: {isBeingAdjusted}</p>
		<p>position: {controlPosition}</p>
	</div>
	<div class="visual">
		<Touchpad
			on:changed={onPositionChanged}
			width={frameWidth}
			height={jacketHeight}
			top={rollVertPadding + rollHeight} />
		<ShadeVisual
			{actualPosition}
			{controlPosition}
			{frameWidth}
			{frameHeight}
			{frameDepth}
			{rollHeight}
			{rollVertPadding}
			{jacketHeight} />
		<svg
			class="position-line"
			class:hidden={!isBeingAdjusted}
			width="500px"
			height="6px"
			viewBox="0 0 500 6"
			version="1.1"
			xmlns="http://www.w3.org/2000/svg"
			xmlns:xlink="http://www.w3.org/1999/xlink"
			style="--position: {positionLineTop}px; ">
			<title>Line</title>
			<g
				id="Page-1"
				stroke="none"
				stroke-width="1"
				fill="none"
				fill-rule="evenodd"
				stroke-dasharray="32,10"
				stroke-linecap="square">
				<line
					x1="0"
					y1="3"
					x2="500"
					y2="3"
					id="Line"
					stroke="#FFFFFF"
					stroke-width="6" />
			</g>
		</svg>
		<svg
			class="pointer-ring"
			class:hidden={!isBeingAdjusted}
			width="64px"
			height="64px"
			viewBox="0 0 64 64"
			version="1.1"
			xmlns="http://www.w3.org/2000/svg"
			xmlns:xlink="http://www.w3.org/1999/xlink"
			style="--position: {pointerRingPosition}px; --position-horiz: {pointerRingLeft}px ">
			<title>pointer ring</title>
			<defs>
				<linearGradient
					x1="50%"
					y1="22.4337159%"
					x2="50%"
					y2="77.7415865%"
					id="linearGradient-1">
					<stop
						stop-color="#FFFFFF"
						stop-opacity="0.477573208"
						offset="0%" />
					<stop
						stop-color="#000000"
						stop-opacity="0.18321132"
						offset="100%" />
				</linearGradient>
				<circle
					id="path-2"
					cx="32"
					cy="32"
					r="25" />
				<filter
					x="-19.0%"
					y="-19.0%"
					width="138.0%"
					height="138.0%"
					filterUnits="objectBoundingBox"
					id="filter-3">
					<feMorphology
						radius="2.5"
						operator="dilate"
						in="SourceAlpha"
						result="shadowSpreadOuter1" />
					<feOffset
						dx="0"
						dy="0"
						in="shadowSpreadOuter1"
						result="shadowOffsetOuter1" />
					<feGaussianBlur
						stdDeviation="2"
						in="shadowOffsetOuter1"
						result="shadowBlurOuter1" />
					<feComposite
						in="shadowBlurOuter1"
						in2="SourceAlpha"
						operator="out"
						result="shadowBlurOuter1" />
					<feColorMatrix
						values="0 0 0 0 1   0 0 0 0 1   0 0 0 0 1  0 0 0 0.770432692 0"
						type="matrix"
						in="shadowBlurOuter1" />
				</filter>
			</defs>
			<g
				id="Page-1"
				stroke="none"
				stroke-width="1"
				fill="none"
				fill-rule="evenodd">
				<g
					id="ui"
					transform="translate(-268.000000, 31.000000)" />
				<g id="pointer-ring" opacity="0.579938616">
					<use
						fill="black"
						fill-opacity="1"
						filter="url(#filter-3)"
						xlink:href="#path-2" />
					<use
						stroke="#FFFFFF"
						stroke-width="4"
						fill-opacity="0.5"
						fill="url(#linearGradient-1)"
						fill-rule="evenodd"
						xlink:href="#path-2" />
				</g>
			</g>
		</svg>
	</div>
</main>
